'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var ROSMenuItem = _react2['default'].createClass({
    displayName: 'ROSMenuItem',

    getInitialState: function getInitialState() {
        return {
            open: false,
            focus: false
        };
    },

    getDefaultProps: function getDefaultProps() {
        return {
            root: false,
            title: ''
        };
    },

    propTypes: {
        root: _react2['default'].PropTypes.bool,
        title: _react2['default'].PropTypes.string
    },

    onTitleClick: function onTitleClick(event) {
        if (this.props.onItemClick) {
            this.props.onItemClick();
        }

        if (this.props.root) {
            var newState = {};

            if (this.props.children.length && !this.state.open) {
                newState.open = true;
            }

            if (this.state.open) {
                newState.open = false;
                newState.focus = false;
            }

            this.setState(newState);
        } else {}

        //if no children, close the menu
        // if(!this.props.children.lenght) {
        //     this.setState(this.getInitialState());
        // }
    },

    onItemsMouseEnter: function onItemsMouseEnter(event) {
        this.setState({
            focus: true
        });
    },

    onItemsMouseLeave: function onItemsMouseLeave(event) {},

    componentDidMount: function componentDidMount() {
        document.addEventListener('click', this.onDocumentClick);
    },

    onDocumentClick: function onDocumentClick(event) {
        console.log(event);
        console.log(_reactDom2['default'].findDOMNode(this));
    },

    render: function render() {
        var menuItemClasses = _classnames2['default']('ros-menuitem', {
            'root': this.props.root,
            'open': this.state.open
        });

        var titleClasses = _classnames2['default']('title', {
            'display-hidden': !this.props.title
        });

        var itemsClasses = _classnames2['default']('items', {
            'open': this.state.open,
            'focus': this.state.focus

        });

        return _react2['default'].createElement(
            'div',
            { className: menuItemClasses },
            _react2['default'].createElement(
                'div',
                { className: 'content' },
                _react2['default'].createElement(
                    'div',
                    { className: titleClasses, onClick: this.onTitleClick },
                    this.props.title
                ),
                _react2['default'].createElement(
                    'div',
                    { className: itemsClasses, onMouseEnter: this.onItemsMouseEnter, onMouseLeave: this.onItemsMouseLeave },
                    this.props.children
                )
            )
        );
    }
});

exports['default'] = ROSMenuItem;
module.exports = exports['default'];